#!/usr/bin/perl -w

use lib "/opt/andrea/bin/";

#use strict;
use DBI;
use Socket;
use Net::FTP;
use loadconfig;

readconfig;

my $DB_DSN      = "DBI:mysql:database=$loadconfig::conf{'DB_DATABASE'};host=$loadconfig::conf{'DB_HOST'}";
my $DB_USER     = $loadconfig::conf{'DB_USER'};
my $DB_PASSWD   = $loadconfig::conf{'DB_PASSWD'};
my $TABLE       = "andrea";

my $dbh = DBI->connect($DB_DSN, $DB_USER,
   $DB_PASSWD) or die "Cannot connect to DB";

my ($i, @hosttoping, @servertoping, @allhosts, $hosts);
my $sql = qq[
             SELECT ipadr, mtype
             FROM andrea
            ];
my $sth = $dbh->prepare($sql);
$sth->execute();

while (my @row = $sth->fetchrow_array ) {
 if($row[1] eq "1") {
  push @hosttoping, $row[0];
 } elsif ($row[1] eq "2") {
  push @servertoping, $row[0];
 }
 push @allhosts, $row[0];
}

$| = 1;

my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year += 1900;
$mon += 1;
if(length($mon) == 1) { $mon = "0".$mon; }
if(length($mday) == 1) { $mday = "0".$mday; }
if(length($hour) == 1) { $hour = "0".$hour; }
if(length($min) == 1) { $min = "0".$min; }
my $date = "$mday.$mon.$year $hour:$min";

my $delmac="";

foreach my $host (@allhosts) {
 my $delmac .= "arp -d $host;";
}
my $status = `$delmac`;

my $allhosts = join(" ", @allhosts);
$status = `/usr/sbin/fping -a -r1 -t10 $allhosts`;

foreach my $host (@allhosts) {
 my $MAXST = 2; # max socket time
 my $MAXCT = 2; # max connect time

 my ($mac, $myname, $macall, $sql, $ftpstat, $httpstat, $sshstat, $vncstat);
 $myname = "";
 $mac = "";
 $macall = `/usr/sbin/arp -a $host|grep $host`;
 chomp($macall);
 if($macall){
  ($myname, undef, undef, $mac, undef) = split(/ /, $macall);
 }
 #print "teste $host... ($mac)\n";
 if($status =~ m/$host/g) {
  if($mac eq "<incomplete>" || substr($mac,0,9) eq "<unvollst" ) {
   #print "abgeschaltet $host\n";
   $sql = qq[
             UPDATE $TABLE
             SET status=0, ftpstat=0, httpstat=0
             WHERE ipadr='$host'
            ];
  } else {
   #print "aktiv $host ($mac)\n";
   if(grep{$_ eq $host} @servertoping) {
    # check for ssh server - port 22
    $sshstat = checkport($host,22);

     # check for a running vnc-server - port 5801 and 5901 on windows machines
   # linux uses other ports too...
     $vncstat = checkport($host,5801);
    if(!$vncstat) { $vncstat = checkport($host,5901); }
    if(!$vncstat) { $vncstat = checkport($host,5800); }
    if(!$vncstat) { $vncstat = checkport($host,5900); }
   }

   # check for ftp server - port 21
   $ftpstat = checkport($host,21);

   # check for http server - port 80
   $httpstat = checkport($host,80);

   #$ = checkport($host,);
   #$ = checkport($host,);

   if($ftpstat) { $ftpstat = ", ftpstat=1"; } else { $ftpstat=", ftpstat=0"; }
   if($httpstat) { $httpstat = ", httpstat=1"; } else { $httpstat=", httpstat=0"; }
   if($sshstat) { $sshstat = ", sshstat=1"; } else { $sshstat=", sshstat=0"; }
   if($vncstat) { $vncstat = ", vncstat=1"; } else { $vncstat=", vncstat=0"; }

   $sql = qq[
             UPDATE $TABLE
             SET status=1, laston='$date' $ftpstat $httpstat $sshstat $vncstat
             WHERE ipadr='$host';
            ];
  }
  $dbh->do($sql) or die "Update failed ($sql)";
 } else {
  #print "abgeschaltet $host\n";
  $sql = qq[
             UPDATE $TABLE
             SET status=0, ftpstat=0, httpstat=0
             WHERE ipadr='$host'
           ];
  $dbh->do($sql) or die "Update failed ($sql)";
 }
}


$dbh->disconnect();  # Datenbankverbindung l.

sub checkport {
 my ($host,$port) = @_;
 my ($ret, $kidpid, $handle, $line);
 my $TIMEOUT = 2;

 # create a tcp connection to the specified host and port
 $handle = IO::Socket::INET->new(Proto     => "tcp",
    PeerAddr  => $host,
    PeerPort  => $port,
    Timeout   => $TIMEOUT)
 or return();

 $handle->autoflush(1);          # so output gets there right away
 $ret = "$host:$port";
 return ($ret);

}
