#!/usr/bin/perl

use lib "/opt/andrea/bin/";

use strict;
use DBI;
use loadconfig;
use File::stat;

readconfig;

my $DB_DSN      = "DBI:mysql:database=$loadconfig::conf{'DB_DATABASE'};host=$loadconfig::conf{'DB_HOST'}";
my $DB_USER     = $loadconfig::conf{'DB_USER'};
my $DB_PASSWD   = $loadconfig::conf{'DB_PASSWD'};
my $TABLE       = "andrea";

my $dbh = DBI->connect($DB_DSN, $DB_USER,
   $DB_PASSWD) or die "Cannot connect to DB";

my @iptwerte=`/sbin/iptables -L -n -t nat`;

my $now = time();
my $ifeth1 = `/sbin/ifconfig eth1|grep Bcast|awk -F':' '{print \$2}'|awk '{print \$1}'`;
chomp($ifeth1);

my $sql = "SELECT ipadr FROM andrea WHERE fwfull=1";
my $sth = $dbh->prepare($sql);

#print $sql."\n";
$sth->execute();

if($sth) {
 while ( my @row = $sth->fetchrow_array ) {
  my $NET = $row[0];

  my $check;

  foreach my $x (@iptwerte) {
   chomp $x;
   next unless $x =~ /$NET.+full $NET/;
   $check="$x";
  }

  if($check){
   #print "$NET ist bereits aktiv!\n";
  }else{
   print $row[0]." wird aktiviert (full)...\n";

   my $ipt = qq[
    /sbin/iptables -t nat -A POSTROUTING -o eth1 -s $NET -j SNAT --to-source $ifeth1 -m comment --comment "full $NET"
   ];
 
   my $start = `$ipt`;
   print "$start\n";
  }
 }
}

$sql = "SELECT port, bem, proto FROM fwports";
$sth = $dbh->prepare($sql);
#print $sql."\n";
$sth->execute();
my @fwports;
 
while ( my @row = $sth->fetchrow_array ) {
 push @fwports, "$row[0]|$row[2]";
}

$sql = "SELECT ipadr FROM andrea WHERE fwfull is NULL or fwfull=0";
$sth = $dbh->prepare($sql);
#print $sql."\n";
$sth->execute();

my $todo;

if($sth) {
 while ( my @row = $sth->fetchrow_array ) {
  my $NET = $row[0];

  foreach my $temp (@fwports) {
   my $check;
   my ($tempport, $tempproto) = split(/\|/, $temp);

   foreach my $x (@iptwerte) {
    chomp $x;
    next unless $x =~ /$tempproto $tempport/; 
    $check="$temp";
   }

   if($check){
    #print "$NET:$temp ist bereits aktiv!\n";
   }else{
    print "$NET:$temp wird aktiviert...\n";
    my ($tempport, $tempproto) = split(/\|/, $temp);

    my $ipt;
    if($tempproto eq "udp"){
     $ipt = qq[ /sbin/iptables -t nat -A POSTROUTING -o eth1 -p $tempproto -s $NET --destination-port $tempport -j SNAT --to-source $ifeth1 -m comment --comment "$tempproto $tempport"; ];
    }else{
     $ipt = qq[ /sbin/iptables -t nat -A POSTROUTING -o eth1 -p $tempproto -s $NET --source-port 1024:65535 --destination-port $tempport -j SNAT --to-source $ifeth1 -m comment --comment "$tempproto $tempport"; ];
    }
    $todo .= "$ipt";
 
    undef $check;
    foreach my $x (@iptwerte) {
     chomp $x;
     next unless $x =~ /$NET.+full $NET/; 
     $check="$temp";
    }

    if($check) {
     # alter eintrag mit full-access vorhanden - muss noch geloescht werden!
     my $ipt = qq[ /sbin/iptables -t nat -D POSTROUTING -o eth1 -p $tempproto -s $NET -j SNAT --to-source $ifeth1 ];
     $todo.="$ipt;"
    }
   }
  }

 }

 my $start = `$todo`;
 print $start;

}

$sth->finish();

$dbh->disconnect();
