#!/bin/bash

. /opt/andrea/conf/andrea.conf

# sprache abfragen 
erkl="Please choose your language - at the moment only german and english are supported\nBitte waehlen Sie die Sprache - momentan werden nur Englisch und Deutsch unterstuetzt."
frage="german or english?" 
def="$language"

clear
echo -e "\n\n$erkl\n"
read -p "$frage (default=$def): " HN
if [ "$HN" ]; then
 language="$HN"
fi

if [ "$language" == "german" ];then
 . /opt/andrea/conf/lang_de.conf
else
 . /opt/andrea/conf/lang_en.conf
fi

# Internet Zugriff via ANDReA
erkl="$INET_E"
frage="$INET_F"
def="$INET_DEF"

clear
echo -e "\n\n$erkl\n"
read -p "$frage (default=$def): " HN
if [ "$HN" ]; then
 INET="$HN"
else
 INET="$def"
fi

PGW=`grep gateway /etc/network/interfaces|awk '{print $2}'`
if [ $INET -eq 1 ]; then
 if ! [ "$PGW" ]; then
  echo -e "\n\n$GWERROR"
  sleep 10
 fi
fi

PADDR=$(ifconfig eth1 | awk '/inet addr/ { gsub(/addr:/, "") ; print $2}')
PMASK=$(ifconfig eth1 | awk '/Mask/ { gsub(/Mask:/, "") ; print $4}')

if ! [ "$PGW" == "$PROVIDER_GW" ];then
 PROVIDER_GW=$PGW
fi

function writeconfig()
{

# alles definiert, jetzt wird die neue config datei geschrieben!
echo -e "\n\
VERSION=\"$VERSION\"\n\
\n\
ANDREAHOSTNAME=\"$ANDREAHOSTNAME\"\n\
language=\"$language\"\n\
\n\
BN_ANDREAIP=\"$BN_ANDREAIP\"\n\
BN_SUBNET=\"$BN_SUBNET\"\n\
BN_NETMASK=\"$BN_NETMASK\"\n\
BN_NETMASKL=\"$BN_NETMASKL\"\n\
BN_ROUTER=\"$BN_ROUTER\"\n\
BN_DNS=\"$BN_DNS\"\n\
BN_DN=\"$BN_DN\"\n\
BN_POOLRANGE=\"$BN_POOLRANGE\"\n\
BN_MINLEASE=\"$BN_MINLEASE\"\n\
BN_MAXLEASE=\"$BN_MAXLEASE\"\n\
\n\
RN_ANDREAIP=\"$RN_ANDREAIP\"\n\
RN_SUBNET=\"$RN_SUBNET\"\n\
RN_NETMASK=\"$RN_NETMASK\"\n\
RN_NETMASKL=\"$RN_NETMASKL\"\n\
RN_ROUTER=\"$RN_ROUTER\"\n\
RN_DNS=\"$RN_DNS\"\n\
RN_DN=\"$RN_DN\"\n\
RN_POOLRANGE=\"$RN_POOLRANGE\"\n\
RN_DNSFORWARD=\"$RN_DNSFORWARD\"\n\
RN_STARTHTML=\"$RN_STARTHTML\"\n\
RN_MINLEASE=\"$RN_MINLEASE\"\n\
RN_MAXLEASE=\"$RN_MAXLEASE\"\n\
RN_WINS=\"$RN_WINS\"\n\
DB_HOST=\"$DB_HOST\"\n\
DB_DATABASE=\"$DB_DATABASE\"\n\
DB_USER=\"$DB_USER\"\n\
DB_PASSWD=\"$DB_PASSWD\"\n\
OTHERDHCP=\"$OTHERDHCP\"\n\
PROVIDER_GW=\"$PROVIDER_GW\"\n\
INET=\"$INET\"\n\
GW_IP=\"$GWIP\"\n\
GW_NM=\"$GWNM\"\n\
GW_IPGW=\"$GWIPGW\"\n\
 " > /opt/andrea/conf/andrea.conf

mv /etc/samba/smb.conf /etc/samba/smb.conf.orig

echo -e "\n\
[global]\n\
\n\
workgroup = andrea\n\
netbios name = andrea\n\
os level = 48\n\
time server = yes\n\
interfaces = $RN_ANDREAIP\n\
security = share\n\
large readwrite = yes\n\
\n\
local master = yes\n\
wins support = yes\n\
dns proxy = yes\n\
domain master = yes\n\
\n\
[beamer]\n\
 comment = diashow\n\
 path = /opt/andrea/http/beamer/diashow\n\
 browseable = yes\n\
 read only = no\n\
 create mask = 0664\n\
 directory mask = 0775\n\
" > /etc/samba/smb.conf

}

if [ "$INET" -eq 1 ]; then

 # Internet Adresse abfagen
 erkl="$GWIP_E"
 frage="$GWIP_F"
 def="$PADDR"
 
 clear
 echo -e "\n\n$erkl\n"
 read -p "$frage (default=$def): " HN
 if [ "$HN" ]; then
  GWIP="$HN"
 else
  GWIP="$def"
 fi

 erkl="$GWNM_E"
 frage="$GWNM_F"
 def="$PMASK"

 clear
 echo -e "\n\n$erkl\n"
 read -p "$frage (default=$def): " HN
 if [ "$HN" ]; then
  GWNM="$HN"
 else
  GWNM="$def"
 fi

 erkl="$GWIPGW_E"
 frage="$GWIPGW_F"
 def="$PGW"
 
 clear
 echo -e "\n\n$erkl\n"
 read -p "$frage (default=$def): " HN
 if [ "$HN" ]; then
  GWIPGW="$HN"
 else
  GWIPGW="$def"
 fi

fi

# zufaelliges netzwerk fuer real netz waehlen
ZUFALLSZAHL=$(($RANDOM % 31))
while [ "$ZUFALLSZAHL" <= "16" ]
do
 ZUFALLSZAHL=$(($RANDOM % 250))
done

RN_ANDREAIP="10.$ZUFALLSZAHL.0.1"
RN_SUBNET="10.$ZUFALLSZAHL.0.0"
RN_ROUTER="10.$ZUFALLSZAHL.0.1"
RN_DNS="10.$ZUFALLSZAHL.0.1"
RN_WINS="10.$ZUFALLSZAHL.0.1"

if [ $INET -eq 1 ]; then
 # DNS Adresse fuer externe Anfragen
 erkl="$DNSFW_E"
 frage="$DNSFW_F" 
 def=`grep '^nameserver' /etc/resolv.conf |head -1|awk '{print $2}'`
 RN_DNSFORWARD=$def

 clear
 echo -e "\n\n$erkl\n"
 read -p "$frage (default=$def): " HN
 if [ "$HN" ]; then
  RN_DNSFORWARD="$HN"
 fi
fi

# Anzahl der Rechner im Netzwerk (max)
erkl="$MAXPC_E"
frage="$MAXPC_F" 
def="$MAXPC"

clear
echo -e "\n\n$erkl\n"
read -p "$frage (default=$def): " HN
if [ "$HN" ]; then
 MAXPC="$HN"
fi

if [ $MAXPC -gt 4000 ]; then
 echo -e "$MAXPCERROR"
 exit 
fi

if [ $MAXPC -le 4000 ]; then
 RN_NETMASK="20"
 RN_NETMASKL="255.255.240.0"
 RN_POOLRANGE="10.$ZUFALLSZAHL.0.2 10.$ZUFALLSZAHL.15.252"
fi

if [ $MAXPC -le 2000 ]; then
 RN_NETMASK="21"
 RN_NETMASKL="255.255.248.0"
 RN_POOLRANGE="10.$ZUFALLSZAHL.0.2 10.$ZUFALLSZAHL.7.252"
fi

if [ $MAXPC -le 1000 ]; then
 RN_NETMASK="22"
 RN_NETMASKL="255.255.252.0"
 RN_POOLRANGE="10.$ZUFALLSZAHL.0.2 10.$ZUFALLSZAHL.3.252"
fi

if [ $MAXPC -le 500 ]; then
 RN_NETMASK="23"
 RN_NETMASKL="255.255.254.0"
 RN_POOLRANGE="10.$ZUFALLSZAHL.0.2 10.$ZUFALLSZAHL.1.252"
fi

if [ $MAXPC -le 250 ]; then
 RN_NETMASK="24"
 RN_NETMASKL="255.255.255.0"
 RN_POOLRANGE="10.$ZUFALLSZAHL.0.2 10.$ZUFALLSZAHL.0.252"
fi

RN_DN="planet.kufstein"

# RNDN real-netz domain name 
erkl="$RNDN_E_T"
frage="$RNDN_F_T"
def="$RN_DN"

clear
echo -e "\n\n$erkl\n"
read -p "$frage (default=$def): " HN
if [ "$HN" ]; then
 RN_DN="$HN"
fi

# URL html Seite auf die weiterverwiesen wird nach der anmeldung
erkl="$URL_E_T"
frage="$URL_F_T"
def="http://www.$RN_DN"

clear
echo -e "\n\n$erkl\n"
read -p "$frage (default=$def): " HN
if [ "$HN" ]; then
 RN_STARTHTML="$HN"
else
 RN_STARTHTML="$def"
fi

## MYPW MySQL Kennwort
## MYPW MySQL Kennwort
erkl="$MYPW_E_T"
frage="$MYPW_F_T"
def="$DB_PASSWD"

clear
echo -e "\n\n$erkl\n"
read -p "$frage: " HN
if [ "$HN" ]; then
 DB_PASSWD="$HN"
else
 DB_PASSWD="$def"
fi

############################### 12 zeilen als vorlage!
## 
#erkl=""
#frage="" 
#def=""
#
#clear
#echo -e "\n\n$erkl\n"
#read -p "$frage (default=$def): " HN
#if [ "$HN" ]; then
# ="$HN"
#fi


writeconfig

exit 0

