#!/usr/bin/perl

use lib "/opt/andrea/bin/";

use strict;
use DBI;
use loadconfig;
use File::stat;

readconfig;

my $DB_DSN      = "DBI:mysql:database=$loadconfig::conf{'DB_DATABASE'};host=$loadconfig::conf{'DB_HOST'}";
my $DB_USER     = $loadconfig::conf{'DB_USER'};
my $DB_PASSWD   = $loadconfig::conf{'DB_PASSWD'};
my $TABLE       = "andrea";

my $dbh = DBI->connect($DB_DSN, $DB_USER,
   $DB_PASSWD) or die "Cannot connect to DB";

my $now = time();
my $ifeth1 = `/sbin/ifconfig eth1|grep Bcast|awk -F':' '{print \$2}'|awk '{print \$1}'`;
chomp($ifeth1);

my $sql = "SELECT ipadr FROM andrea WHERE fwfull=0";
my $sth = $dbh->prepare($sql);
#print $sql."\n";
$sth->execute();

if($sth) {
 while ( my @row = $sth->fetchrow_array ) {
  my $NET = $row[0];

  my $check =  `/sbin/iptables -t nat -L -n|grep SNAT|grep $NET|grep 'tcp spts:1024:65535 to:$ifeth1' `;

  if(!$check){
   #print "$NET ist nicht in der iptables Liste!\n";
  }else{
   print $row[0]." wird deaktiviert...\n";

   my $ipt = qq[
    /sbin/iptables -t nat -D POSTROUTING -o eth1 -p tcp -s $NET --source-port 1024:65535 -j SNAT --to-source $ifeth1
#    /sbin/iptables -D INPUT  -i eth1  -s $NET  -m state --state NEW  -j ACCEPT
#    /sbin/iptables -D FORWARD  -i eth1  -s $NET  -m state --state NEW  -j ACCEPT
#    /sbin/iptables -D FORWARD  -o eth1  -s $NET  -m state --state NEW  -j ACCEPT
   ];
 
   my $start = `$ipt`;
   print "$start\n";
  }
 }
}

$sth->finish();

$dbh->disconnect();
