#!/bin/bash

/opt/andrea/bin/config.sh

if [ "$?" == "1" ]; then
 echo "error during config..."
 exit 1;
fi

cd /opt/andrea/bin

. /opt/andrea/conf/andrea.conf

#######################################
# netzwerkschnittstellen aktivieren...
#######################################

cp /etc/network/interfaces /etc/network/interfaces.orig

if [ $INET -eq 1 ]; then

 echo "
auto lo
iface lo inet loopback

mapping hotplug
	script grep
	map eth0
	map eth1

auto eth1
iface eth1 inet static
address $GW_IP
netmask $GW_NM
gateway $GW_IPGW

auto eth0
iface eth0 inet static
address $BN_ANDREAIP
netmask $BN_NETMASKL

auto eth0:1
iface eth0:1 inet static
address $RN_ANDREAIP
netmask $RN_NETMASKL

" > /etc/network/interfaces

else

 echo "
auto lo
iface lo inet loopback

mapping hotplug
        script grep
        map eth0

auto eth0
iface eth0 inet static
address $BN_ANDREAIP
netmask $BN_NETMASKL

auto eth0:1
iface eth0:1 inet static
address $RN_ANDREAIP
netmask $RN_NETMASKL

" > /etc/network/interfaces

fi


if [ $INET -eq 1 ]; then
 # wenn eth1 dann firewall vorbereiten
 ETH1=`/sbin/ifconfig eth1|grep Bcast|awk -F':' '{print $2}'|awk '{print $1}'`

 if ! [ "$ETH1" ]; then
  echo -e "\n\nNetzwerkschnittstelle eth1 nicht installiert/konfiguriert, es wird keine Firewall installiert! \n\n\n"
  sleep 4
 else
  if ! [ -d "/etc/firewall" ]; then
   mkdir /etc/firewall
  fi
  cp /opt/andrea/conf/login.fw /etc/firewall/login.fw
  chmod 0700 /etc/firewall/login.fw
 fi
fi

if [ "$language" == "german" ];then
 . /opt/andrea/conf/lang_de.conf
else
 . /opt/andrea/conf/lang_en.conf
fi



# config files sind bei ubuntu andere...
NAMED="/etc/bind/named.conf"

# MAC-Adresse ermittlen
MAC=`/sbin/ifconfig eth0|grep eth0|awk '{print $5}'`
if ! [ "$MAC" ];then
 MAC=`/sbin/ifconfig eth0|grep eth0|awk '{print $4}'`
fi
MAC1=`/sbin/ifconfig eth1|grep eth1|awk '{print $5}'`
if ! [ "$MAC1" ];then
 MAC1=`/sbin/ifconfig eth1|grep eth1|awk '{print $4}'`
fi

echo "eth0 mac $MAC" > /etc/iftab
if [ "$MAC1" ]; then
 echo "eth1 mac $MAC1" >> /etc/iftab
fi

if [ $INET -eq 1 ]; then
 # copy firewall start script
 cp /opt/andrea/bin/firewall /etc/init.d/
 update-rc.d firewall defaults 95
fi

# style.css anpassen
sed -e "s/login.planet.kufstein/$ANDREAHOSTNAME.$RN_DN/g" /opt/andrea/http/style.css > /opt/andrea/http/style.css.new
mv /opt/andrea/http/style.css /opt/andrea/http/style.css.orig
mv /opt/andrea/http/style.css.new /opt/andrea/http/style.css

# include wert für named setzen
CONFPFAD="/etc/bind/named.andrea.conf"

GETINCLUDE=`grep $CONFPFAD $NAMED`
if ! [ "$GETINCLUDE" ];then
 if ! [ -f "$NAMED.orig" ]; then
  cp $NAMED $NAMED.orig
 fi
 echo "include \"$CONFPFAD\"; " >> $NAMED
fi

# include datei im named.d verzeichnis erstellen
echo -e "zone \"$RN_DN\" {\n        type master;\n        file \"/etc/bind/db.real.net\"; \n};" > /etc/bind/named.andrea.conf

# andrea.http anpassen
sed -e "s/planet.kufstein/$RN_DN/g" /opt/andrea/conf/andrea.http > /opt/andrea/conf/andrea.http.new
mv /opt/andrea/conf/andrea.http /opt/andrea/conf/andrea.http.orig
mv /opt/andrea/conf/andrea.http.new /opt/andrea/conf/andrea.http

# apache start fuer andrea aktivieren
CONFPFAD=/opt/andrea/conf/andrea.http

cp $CONFPFAD /etc/apache2/sites-available/andrea
if ! [ -f "/etc/apache2/sites-enabled/000-andrea" ];then
 if [ -f "/etc/apache2/sites-enabled/000-default" ];then
  rm /etc/apache2/sites-enabled/000-default
 fi
 ln -s /etc/apache2/sites-available/andrea /etc/apache2/sites-enabled/000-andrea 
fi

if [ $INET -eq 1 ]; then

 # crontab fuer andrea erzeugen
 if ! [ -f "/etc/cron.d/andrea" ]; then
ACT=/opt/andrea/bin/active.pl
PAS=/opt/andrea/bin/passiv.pl
DHCP=/opt/andrea/bin/upd_dhcp.sh
DNS=/opt/andrea/bin/upd_dns.sh
CHKDHCP=/opt/andrea/bin/chkdhcp.sh
ACTFW=/opt/andrea/bin/akt_ipfw.pl
DEACTFW=/opt/andrea/bin/deakt_ipfw.pl
STARTDHCP=/etc/init.d/dhcp3-server
echo "
 */5 * * * * root $ACT > /dev/null 2>&1
 */15 * * * * root $PAS > /dev/null 2>&1
 * * * * * root $DHCP > /dev/null 2>&1
 * * * * * root $DNS > /dev/null 2>&1
 * * * * * root $CHKDHCP > /dev/null 2>&1
 * * * * * root $ACTFW >> /var/log/andrea_aktfw.log 2>&1
 * * * * * root $DEACTFW >> /var/log/andrea_aktfw.log 2>&1
 * * * * *    root   $STARTDHCP start > /dev/null 2>&1
" > /etc/cron.d/andrea
 fi
else

if ! [ -f "/etc/cron.d/andrea" ]; then
ACT=/opt/andrea/bin/active.pl
PAS=/opt/andrea/bin/passiv.pl
DHCP=/opt/andrea/bin/upd_dhcp.sh
DNS=/opt/andrea/bin/upd_dns.sh
CHKDHCP=/opt/andrea/bin/chkdhcp.sh
STARTDHCP=/etc/init.d/dhcp3-server
echo "
 */5 * * * * root $ACT > /dev/null 2>&1
 */15 * * * * root $PAS > /dev/null 2>&1
 * * * * * root $DHCP > /dev/null 2>&1
 * * * * * root $DNS > /dev/null 2>&1
 * * * * * root $CHKDHCP > /dev/null 2>&1
 * * * * *    root   $STARTDHCP start > /dev/null 2>&1
" > /etc/cron.d/andrea
 fi
fi

# chown für htpasswd damit man das admin kennwort ändern kann!
/bin/chown www-data /opt/andrea/conf/htpasswd
/bin/chown -R www-data:www-data /opt/andrea/http
/bin/chown -R www-data:www-data /opt/andrea/conf
if ! [ -d /opt/andrea/http/log ]; then
 mkdir /opt/andrea/http/log
fi

# user fuer beamer anlegen
/usr/sbin/useradd -s /bin/false -d /opt/andrea/http/beamer/diashow beamer
echo -e "test\ntest\n"|/usr/bin/smbpasswd -s -a beamer

/etc/init.d/mysql restart

if [ "$DB_PASSWD" ]; then
 mysqladmin -u $DB_USER --password="$DB_PASSWD" create andrea
 mysql -u $DB_USER --password="$DB_PASSWD" andrea < /opt/andrea/http/andrea.sql
 mysql -u $DB_USER --password="$DB_PASSWD" -e "use andrea;INSERT INTO andrea SET ipadr='$RN_ANDREAIP',macadr='$MAC',idnum=999999,nickname='$ANDREAHOSTNAME',status=1, alias='beamer', mtype='2', fwfull='1', dhcpoff='0' "
else 
 mysqladmin -u $DB_USER create andrea
 mysql -u $DB_USER andrea < /opt/andrea/http/andrea.sql
 mysql -u $DB_USER -e "use andrea;INSERT INTO andrea SET ipadr='$RN_ANDREAIP',macadr='$MAC',idnum=999999,nickname='$ANDREAHOSTNAME',status=1, alias='beamer', mtype='2', fwfull='1', dhcpoff='0' "
fi

# init hosts datenbank
echo "$INSDBH"
/opt/andrea/bin/initmysql.sh

# wenn kein leases file existiert anlegen
if ! [ -f "/var/lib/dhcp3/dhcpd.leases" ]; then
 touch /var/lib/dhcp3/dhcpd.leases
fi
echo "INTERFACES=\"eth0\"" > /etc/default/dhcp3-server

# resolv.conf 
cp /etc/resolv.conf /etc/resolv.conf.orig
echo "domain $RN_DN" > /etc/resolv.conf
echo "nameserver 127.0.0.1" >> /etc/resolv.conf



cp /etc/dhcp3/dhcpd.conf /etc/dhcp3/dhcpd.conf.orig

/opt/andrea/bin/build_dhcp.pl
if [ -f "/etc/dhcp3/dhcpd.conf.new" ]; then
 cp /etc/dhcp3/dhcpd.conf.new /etc/dhcp3/dhcpd.conf
fi

/opt/andrea/bin/build_dns.pl
if [ -f "/etc/bind/db.real.net.new" ]; then
 cp /etc/bind/db.real.net.new /etc/bind/db.real.net
fi

/usr/sbin/update-rc.d mysql defaults
/usr/sbin/update-rc.d bind9 defaults
/usr/sbin/update-rc.d samba defaults
/usr/sbin/update-rc.d apache2 defaults
if [ $INET -eq 1 ]; then
 /usr/sbin/update-rc.d firewall defaults
fi
/usr/sbin/update-rc.d dhcp3-server defaults

/etc/init.d/networking restart
/etc/init.d/bind9 restart
/etc/init.d/samba restart
/etc/init.d/apache2 restart
if [ $INET -eq 1 ]; then
 /etc/init.d/firewall start
fi
/etc/init.d/dhcp3-server start

export DOCUMENT_ROOT="/opt/andrea/http/"
php gencode.php
#w3m http://andrea:default@127.0.0.1/admin/gencode.php > /dev/null

echo -e "$OKINSTMSG"

exit 0

# boot.local so verändern dass dhcplog.sh gestartet wird!
#CONFPFAD=/opt/andrea/bin/dhcplog.sh
#
#GETINCLUDE=`grep $CONFPFAD $BOOT`
#
#if ! [ "$GETINCLUDE" ];then
# echo "/opt/andrea/bin/dhcplog.sh &" >> $BOOT
#fi

