#!/usr/bin/perl -w

use lib "/opt/andrea/bin/";

use strict;
use DBI;
use IP qw(:PROC);
use loadconfig;

readconfig;

my $DB_DSN      = "DBI:mysql:database=$loadconfig::conf{'DB_DATABASE'};host=$loadconfig::conf{'DB_HOST'}";
my $DB_USER     = $loadconfig::conf{'DB_USER'};
my $DB_PASSWD   = $loadconfig::conf{'DB_PASSWD'};
my $TABLE       = "attention";

$| = 1;

my $tst=time;
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year += 1900;
$mon += 1;
if(length($mon) == 1) { $mon = "0".$mon; }
if(length($mday) == 1) { $mday = "0".$mday; }
if(length($hour) == 1) { $hour = "0".$hour; }
if(length($min) == 1) { $min = "0".$min; }
my $date = "$mday.$mon.$year $hour:$min";

my $dbh = DBI->connect($DB_DSN, $DB_USER,
   $DB_PASSWD) or die "Cannot connect to DB";

my ($rn_subnet, $rn_netmask, %okhosts, $sql, %checkhosts, $key, $val);

# alle angemeldeten host einlesen
andreahosts();
atthosts();

$rn_subnet = $loadconfig::conf{'RN_SUBNET'};
$rn_netmask = $loadconfig::conf{'RN_NETMASK'};

my @ip = split(/\./, $rn_subnet);
if($ip[0] > 0) { $rn_subnet = $ip[0]; }
if($ip[1] > 0) { $rn_subnet .= ".".$ip[1]; }
if($ip[2] > 0) { $rn_subnet .= ".".$ip[2]; }
if($ip[3] > 0) { $rn_subnet .= ".".$ip[3]; }

my ($i, @toping, $hosts);
my $ip = new IP($rn_subnet.'/'.$rn_netmask) or die (IP::Error());
my $endip = $ip->last_ip();
my $startip = $ip->ip();
my $starttime=time();


while (($key,$val) = each %checkhosts) {
 $i++;
 my $host = $val;
 my $status = `fping -a -r1 -t10 -q $host`;
 &aktdb($host,$status);
 #print "$i > $host,$status\n";
};

my $endtime=time()-$starttime;




print $endtime." Sekunden\n";

sub aktdb {
 my ($host,$status) = @_;
 my ($myname, $test, $mac);
 $test = rindex $status, $host;
 if($test == 0) {
  my $macall = `arp -a $host`;
  ($myname, undef, undef, $mac, undef) = split(/ /, $macall);
  if($mac eq "entries" || $mac eq "Eintrgen") {
   $mac=`ifconfig eth0|grep eth0|awk '{print \$5}'`;
  }
  chomp $mac;
  $sql="UPDATE $TABLE SET status='1',laston='$date',macadr='$mac' WHERE ipadr='$host'";
  #print $sql;
  $dbh->do($sql);
  $sql="INSERT into active SET ipadr='$host', status='1', tst='$tst'";
  #print $sql;
  $dbh->do($sql);
  if($okhosts{"$host"}) {
   if(length($mac)==17) {
    $sql="UPDATE andrea SET status='1',laston='$date',macadr='$mac' WHERE ipadr='$host'";
    #print $sql;
    $dbh->do($sql);
   }
  }
 } else {
  $dbh->do("UPDATE $TABLE SET status='0' WHERE ipadr='$host'");
  $sql="INSERT into active SET ipadr='$host', status='0', tst='$tst'";
  $dbh->do($sql);
 }
}

sub andreahosts {
 my $sql = qq[
             SELECT ipadr, macadr
             FROM andrea
            ];
 my $sth = $dbh->prepare($sql);
 $sth->execute();
 while (my @row = $sth->fetchrow_array ) {
  $okhosts{$row[0]}=$row[1];
 }
 return;
}

sub atthosts {
 my $sql = qq[
             SELECT id,ipadr
             FROM attention
            ];
 my $sth = $dbh->prepare($sql);
 $sth->execute();
 while (my @row = $sth->fetchrow_array ) {
  $checkhosts{$row[0]}=$row[1];
 }
 return;
}

$dbh->disconnect();  # Datenbankverbindung lsen.

