#!/bin/bash

. /opt/andrea/conf/andrea.conf

if [ -f "/etc/network/interfaces.orig" ]; then
 cp /etc/network/interfaces.orig /etc/network/interfaces
 /sbin/ifconfig eth0:1 down
 /sbin/ifconfig eth0 down
 /sbin/ifconfig eth1 down
 /etc/init.d/networking restart
fi

/etc/init.d/dhcp3-server stop
/usr/sbin/update-rc.d -f dhcp3-server remove

if [ $INET -eq 1 ]; then
 rm /etc/firewall/login.fw
 /etc/init.d/firewall stop
 /usr/sbin/update-rc.d -f firewall remove
 /sbin/iptables -P INPUT ACCEPT
 /sbin/iptables -P OUTPUT ACCEPT
 /sbin/iptables -P FORWARD ACCEPT
fi

NAMED="/etc/bind/named.conf"
if [ -f "/etc/bind/named.andrea.conf" ]; then
 rm /etc/bind/named.andrea.conf
fi

if [ -f "$NAMED.orig" ]; then
 cp "$NAMED.orig" $NAMED
 /etc/init.d/bind9 restart
else
 /etc/init.d/bind9 stop
 rm $NAMED
 /usr/sbin/update-rc.d -f bind9 remove
fi

if [ -f "/etc/apache2/sites-enabled/000-andrea" ]; then
 /etc/init.d/apache2 stop
 rm /etc/apache2/sites-enabled/000-andrea
 rm /etc/apache2/sites-available/andrea
 /etc/init.d/apache2 start
fi

if [ -f "/etc/cron.d/andrea" ]; then
 rm /etc/cron.d/andrea
fi

smbpasswd -x beamer

/etc/init.d/mysql stop
if [ -d "/var/lib/mysql/andrea" ]; then
 rm -R /var/lib/mysql/andrea
fi
/etc/init.d/mysql start

if [ -f "/etc/resolv.conf.orig" ]; then
 cp /etc/resolv.conf.orig /etc/resolv.conf
fi

if [ -f "/etc/bind/db.real.net" ]; then
 rm /etc/bind/db.real.net
fi

if [ -f "/etc/bind/db.real.net.new" ]; then
 rm /etc/bind/db.real.net.new
fi

if [ -f "/etc/samba/smb.conf.orig" ]; then
 cp /etc/samba/smb.conf.orig /etc/samba/smb.conf
 /etc/init.d/samba restart
fi

rm -r /opt/andrea

exit 0
