#!/bin/sh

. /opt/andrea/conf/andrea.conf

cd /opt/andrea/bin/

BINPFAD=/opt/andrea/bin
INITPFAD=/etc/init.d/dhcp3-server
CONFPFAD=/etc/dhcp3
DHCPCONF=/etc/dhcp3/dhcpd.conf

/opt/andrea/bin/build_dhcp.pl

DIFF=`diff -q $CONFPFAD/dhcpd.conf.new $DHCPCONF`

if [ "$DIFF" == "" ]; then
 #echo "kein Update notwendig!"
 exit
fi

cp $CONFPFAD/dhcpd.conf $CONFPFAD/dhcpd.conf.bak
cp $CONFPFAD/dhcpd.conf.new $DHCPCONF

CHECKDHCP=`dhcpd3 -t -cf $DHCPCONF | grep 'error'`

if ! [ "$CHECKDHCP" ]; then
 SERVERSTART=`$INITPFAD force-reload | grep -C1 'Starting DHCP server' | grep '[ ok ]'`
 if [ "$SERVERSTART" ]; then
  time=`date "+%b %d %H:%M:%S"`
  echo "$time DHCP update successful!" >> /var/log/messages
  # kopiere aktuelle config als last known good backup datei!
  cp $CONFPFAD/dhcpd.conf $CONFPFAD/dhcpd.conf.lng
 else
  (
   echo "To: Cheffe <root@localhost>"
   echo "From: DHCP01 <root@localhost>"
   echo "Subject: Fehler beim DHCP Server Start!"
   echo "Der DHCP Server konnte nicht gestartet werden!"
   echo "Bitte Config Files prfen und hndisch starten."
   echo ""
   echo "Versuche den Server mit der letzten funktionierenden Config-"
   echo "Datei zu starten!"
  ) 2>&1 | /usr/lib/sendmail -t
  cp $CONFPFAD/dhcpd.conf.lng $CONFPFAD/dhcpd.conf
  $INITPFAD restart
 fi
else
 CHECKDHCPFULL=`dhcpd3 -t -cf $DHCPCONF`
 cp $CONFPFAD/dhcpd.conf.bak $DHCPCONF
 (
  echo "To: Cheffe <root@localhost>"
  echo "From: DHCP01 <root@localhost>"
  echo "Subject: Fehler in dhcpd.conf!"
  echo "Bitte die Datei hndisch checken, neue Config konnte"
  echo "nicht aktiviert werden!"
  echo "Check $CONFPFAD/dhcpd.conf.new"
  echo ""
  echo "Ausgabe von $INITPFAD check-syntax:"
  echo ""
  echo "$CHECKDHCPFULL"
  echo ""
  echo "$CHECKDHCP"
  echo ""
 ) 2>&1 | /usr/lib/sendmail -t
fi

