#!/bin/bash

cd /opt/andrea/bin

. /opt/andrea/conf/andrea.conf

BINPFAD=/opt/andrea/bin
CONFPFAD=/etc/bind

/opt/andrea/bin/build_dns.pl

if ! [ -s "$CONFPFAD/db.real.net" ]; then
 touch $CONFPFAD/db.real.net
fi

DIFF=`diff -q $CONFPFAD/db.real.net.new $CONFPFAD/db.real.net`

if [ "$DIFF" == "" ]; then
 echo "kein Update notwendig!"
 exit
fi

CHECKDNS=`/usr/sbin/named-checkzone real.net $CONFPFAD/db.real.net.new | tail -1| grep 'OK'`

if [ "$CHECKDNS" ]; then
 cp $CONFPFAD/db.real.net.new $CONFPFAD/db.real.net
 $BINPFAD/mkrdns.pl /etc/bind/named.conf >/dev/null 2>&1
 SERVERSTART=`/etc/init.d/bind9 reload | tail -1 | grep '[ ok ]'`
 if [ "$SERVERSTART" ]; then
  time=`date "+%b %d %H:%M:%S"`
  echo "$time DNS update successful!" >> /var/log/messages
  # kopiere aktuelle config als last known good backup datei!
  cp $CONFPFAD/db.real.net $CONFPFAD/db.real.net.lng
 else
  (
   echo "To: Cheffe <root@localhost>"
   echo "From: DHCP01 <root@localhost>"
   echo "Subject: Fehler beim DNS Server Start!"
   echo "Der DNS Server konnte nicht gestartet werden!"
   echo "Bitte Config Files prfen und hndisch starten."
   echo ""
   echo "Versuche den Server mit der letzten funktionierenden Config-"
   echo "Datei zu starten!"
  ) 2>&1 | /usr/lib/sendmail -t
  cp $CONFPFAD/db.real.net.lng $CONFPFAD/db.real.net
  /etc/init.d/bind9 reload
 fi
else
 (
  CHECKDNSFULL=`/usr/sbin/named-checkzone real.net $CONFPFAD/db.real.net.new`
  echo "To: Cheffe <root@localhost>"
  echo "From: DHCP01 <root@localhost>"
  echo "Subject: DNS-Fehler in $CONFPFAD/db.real.net.new"
  echo "Bitte die Datei hndisch checken, neue Config konnte"
  echo "nicht aktiviert werden!"
  echo "check $CONFPFAD/db.real.net.new and /var/log/messages"
  echo ""
  echo "Ausgabe von named-checkzone"
  echo ""
  echo "$CHECKDNSFULL"
 ) 2>&1 | /usr/lib/sendmail -t
fi


