-- MySQL dump 8.21
--
-- Host: localhost    Database: andrea
---------------------------------------------------------
-- Server version       3.23.49-log

--
-- Table structure for table 'andrea'
--

-- Haupttabelle mit den angemeldeten rechnern und deren daten (ftp-server, http-server & co)

CREATE TABLE `andrea` (
  `ipadr` varchar(15) NOT NULL,
  `macadr` varchar(17) NOT NULL,
  `idnum` integer(11) NOT NULL,
  `nickname` varchar(12) default NULL,
  `status` char(1) default NULL,
  `laston` varchar(18) default NULL,
  `ftpstat` char(1) default NULL,
  `sshstat` char(1) default NULL,
  `httpstat` char(1) default NULL,
  `vncstat` varchar(5) default NULL,
  `alias` varchar(50) default NULL,
  `fwfull` char(1) default NULL,
  `mtype` char(1) default NULL,
  `dhcpoff` char(1) default NULL,
  PRIMARY KEY  (`idnum`),
  UNIQUE KEY `idx_idnum` (`idnum`),
  UNIQUE KEY `idx_ipadr` (`ipadr`),
  UNIQUE KEY `idx_macadr` (`macadr`)
) TYPE=MyISAM; 

--
-- Table structure for table 'codeip'
--

-- Tabelle mit den Anmeldedaten, mit welchem Code bekommt man welche ip-adresse

CREATE TABLE codeip (
  idnum int(11) NOT NULL auto_increment,
  code varchar(8) NOT NULL,
  ipadr varchar(15) default NULL,
  xcor int(11),
  ycor int(11),
  UNIQUE KEY idx_code (code),
  UNIQUE KEY idx_ip (ipadr),
  PRIMARY KEY  (idnum)
) TYPE=MyISAM;


-- 
-- Table structure for table 'attention'
--

-- tabelle in denen hosts vermerkt werden die nicht online sein sollten!

CREATE TABLE attention (
  id int(11) NOT NULL auto_increment,
  ipadr varchar(15) default NULL,
  macadr varchar(17) NOT NULL,
  status char(1) default NULL,
  laston char(18) default NULL,
  bem varchar(150) default NULL,
  PRIMARY KEY (id),
  UNIQUE KEY idx_ipadr (ipadr)
) TYPE=MyISAM;

-- 
-- Table structure for table 'dhcperror'
--

-- tabelle in denen hosts vermerkt werden die einen dhcp server aktiviert haben

CREATE TABLE dhcperror (
  id int(11) NOT NULL auto_increment,
  laston char(18) default NULL,
  bem varchar(150) default NULL,
  PRIMARY KEY (id)
) TYPE=MyISAM;

CREATE TABLE fwports (
  id int(11) NOT NULL auto_increment,
  port int(6),
  bem varchar(50) default NULL,
  proto varchar(3),
  PRIMARY KEY (id)
) TYPE=MyISAM;

INSERT INTO fwports VALUES (1,80,'classic http','tcp');
INSERT INTO fwports VALUES (2,443,'classic https','tcp');
INSERT INTO fwports VALUES (3,110,'classic pop3','tcp');
INSERT INTO fwports VALUES (4,5190,'clasic icq','tcp');
INSERT INTO fwports VALUES (5,143,'classic imap','tcp');
INSERT INTO fwports VALUES (6,25,'classic smtp','tcp');
INSERT INTO fwports VALUES (7,6667,'classic irc','tcp');
INSERT INTO fwports VALUES (8,6668,'classic irc','tcp');
INSERT INTO fwports VALUES (9,6669,'classic irc','tcp');
INSERT INTO fwports VALUES (10,22,'classic ssh','tcp');

CREATE TABLE chkoport (
  id int(11) NOT NULL auto_increment,
  port int(6),
  bem varchar(50) default NULL,
  PRIMARY KEY (id)
) TYPE=MyISAM;


CREATE TABLE active (
  ipadr char(15) NOT NULL,
  status int(1) default NULL,
  tst int(14) NOT NULL,
  PRIMARY KEY (tst, ipadr)
) TYPE=MyISAM;

CREATE TABLE beamer (
  id int(11) NOT NULL auto_increment,
  start int(11) NOT NULL default '0',
  ende int(11) NOT NULL default '0',
  beschreibung varchar(100) NOT NULL,
  verz varchar(50) NOT NULL,
  timeout int(4) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

